package com.csc349blum.scrollingacronyms;

import java.io.InputStream;

import org.json.JSONArray;
import org.json.JSONObject;

import android.os.Bundle;
import android.app.Activity;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TableRow;
import android.widget.Toast;

public class MainActivity extends Activity {

	//JSON Object and Array declared globally
		JSONObject myJSON_object;
		JSONArray myJSON_array;
		
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		//read JSON file as shown previously
		try{
		//http://stackoverflow.com/questions/6420293/reading-android-raw-text-file
			InputStream is = getResources().openRawResource(R.raw.acronyms);
		    byte[] buffer = new byte[is.available()];
		    while (is.read(buffer) != -1);
	   
		    String myText = new String(buffer);
		
		    //http://stackoverflow.com/questions/9605913/how-to-parse-json-in-android
		    //extract the main (top-level) JSON object from the file read above
		    myJSON_object = new JSONObject(myText);
		    
		    //the main JSON object is/includes an array called employees
		    //extract that array
		    myJSON_array = myJSON_object.getJSONArray("acronyms");
		
		    LinearLayout my_inner_scroll = (LinearLayout) findViewById(R.id.lay_scroll);
		    int i;
		    for(i=0;i<myJSON_array.length();i++){
		    	Button myBut = new Button(this);
				myBut.setLayoutParams(new LinearLayout.LayoutParams(
						LinearLayout.LayoutParams.MATCH_PARENT,
						LinearLayout.LayoutParams.MATCH_PARENT,
						1.0f
						));
				JSONObject aJSON_element = myJSON_array.getJSONObject(i);
	    		//get the individual properties of the JSON element
	    		String acro = aJSON_element.getString("acronym");
				myBut.setText(acro);
	    		String spell = aJSON_element.getString("spelledOut");
				myBut.setTag(spell);
				
				myBut.setPadding(0, 0, 0, 0);
				my_inner_scroll.addView(myBut);
				
				myBut.setOnClickListener(new OnClickListener(){
					@Override
					public void onClick(View v) {
						Button me = (Button) v;
						Toast.makeText(getBaseContext(), me.getTag().toString(), Toast.LENGTH_SHORT).show();		
					}//end onClick
				});//end setOnClickListener
		    } //end loop over JSON_array
		    
			}
			catch(Exception e){
					Toast.makeText(getBaseContext(), "Problem with file", Toast.LENGTH_SHORT).show();
					e.printStackTrace();
			}  
	} //end onCreate

}//end class
